<?php

namespace fk_\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPaketZimmet ArrayType
 * @subpackage Arrays
 */
class ArrayOfPaketZimmet extends AbstractStructArrayBase
{
    /**
     * The PaketZimmet
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \fk_\StructType\PaketZimmet[]
     */
    public $PaketZimmet;
    /**
     * Constructor method for ArrayOfPaketZimmet
     * @uses ArrayOfPaketZimmet::setPaketZimmet()
     * @param \fk_\StructType\PaketZimmet[] $paketZimmet
     */
    public function __construct(array $paketZimmet = array())
    {
        $this
            ->setPaketZimmet($paketZimmet);
    }
    /**
     * Get PaketZimmet value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \fk_\StructType\PaketZimmet[]|null
     */
    public function getPaketZimmet()
    {
        return isset($this->PaketZimmet) ? $this->PaketZimmet : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPaketZimmet method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaketZimmet method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaketZimmetForArrayConstraintsFromSetPaketZimmet(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPaketZimmetPaketZimmetItem) {
            // validation for constraint: itemType
            if (!$arrayOfPaketZimmetPaketZimmetItem instanceof \fk_\StructType\PaketZimmet) {
                $invalidValues[] = is_object($arrayOfPaketZimmetPaketZimmetItem) ? get_class($arrayOfPaketZimmetPaketZimmetItem) : sprintf('%s(%s)', gettype($arrayOfPaketZimmetPaketZimmetItem), var_export($arrayOfPaketZimmetPaketZimmetItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PaketZimmet property can only contain items of type \fk_\StructType\PaketZimmet, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PaketZimmet value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\PaketZimmet[] $paketZimmet
     * @return \fk_\ArrayType\ArrayOfPaketZimmet
     */
    public function setPaketZimmet(array $paketZimmet = array())
    {
        // validation for constraint: array
        if ('' !== ($paketZimmetArrayErrorMessage = self::validatePaketZimmetForArrayConstraintsFromSetPaketZimmet($paketZimmet))) {
            throw new \InvalidArgumentException($paketZimmetArrayErrorMessage, __LINE__);
        }
        if (is_null($paketZimmet) || (is_array($paketZimmet) && empty($paketZimmet))) {
            unset($this->PaketZimmet);
        } else {
            $this->PaketZimmet = $paketZimmet;
        }
        return $this;
    }
    /**
     * Add item to PaketZimmet value
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\PaketZimmet $item
     * @return \fk_\ArrayType\ArrayOfPaketZimmet
     */
    public function addToPaketZimmet(\fk_\StructType\PaketZimmet $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \fk_\StructType\PaketZimmet) {
            throw new \InvalidArgumentException(sprintf('The PaketZimmet property can only contain items of type \fk_\StructType\PaketZimmet, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PaketZimmet[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \fk_\StructType\PaketZimmet|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \fk_\StructType\PaketZimmet|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \fk_\StructType\PaketZimmet|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \fk_\StructType\PaketZimmet|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \fk_\StructType\PaketZimmet|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PaketZimmet
     */
    public function getAttributeName()
    {
        return 'PaketZimmet';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\ArrayType\ArrayOfPaketZimmet
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
