<?php

namespace fk_\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KEkHizmet StructType
 * @subpackage Structs
 */
class KEkHizmet extends Tanim
{
    /**
     * The SiraNo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $SiraNo;
    /**
     * The KdvOran
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $KdvOran;
    /**
     * Constructor method for KEkHizmet
     * @uses KEkHizmet::setSiraNo()
     * @uses KEkHizmet::setKdvOran()
     * @param int $siraNo
     * @param float $kdvOran
     */
    public function __construct($siraNo = null, $kdvOran = null)
    {
        $this
            ->setSiraNo($siraNo)
            ->setKdvOran($kdvOran);
    }
    /**
     * Get SiraNo value
     * @return int
     */
    public function getSiraNo()
    {
        return $this->SiraNo;
    }
    /**
     * Set SiraNo value
     * @param int $siraNo
     * @return \fk_\StructType\KEkHizmet
     */
    public function setSiraNo($siraNo = null)
    {
        // validation for constraint: int
        if (!is_null($siraNo) && !(is_int($siraNo) || ctype_digit($siraNo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($siraNo, true), gettype($siraNo)), __LINE__);
        }
        $this->SiraNo = $siraNo;
        return $this;
    }
    /**
     * Get KdvOran value
     * @return float
     */
    public function getKdvOran()
    {
        return $this->KdvOran;
    }
    /**
     * Set KdvOran value
     * @param float $kdvOran
     * @return \fk_\StructType\KEkHizmet
     */
    public function setKdvOran($kdvOran = null)
    {
        // validation for constraint: float
        if (!is_null($kdvOran) && !(is_float($kdvOran) || is_numeric($kdvOran))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($kdvOran, true), gettype($kdvOran)), __LINE__);
        }
        $this->KdvOran = $kdvOran;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\StructType\KEkHizmet
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
