<?php

namespace fk_\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Sirket StructType
 * @subpackage Structs
 */
class Sirket extends Entity
{
    /**
     * The IsArchive
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsArchive;
    /**
     * The Kodu
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Kodu;
    /**
     * The Unvani
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Unvani;
    /**
     * The KisaAdi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $KisaAdi;
    /**
     * The VergiDairesi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $VergiDairesi;
    /**
     * The VergiNo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $VergiNo;
    /**
     * Constructor method for Sirket
     * @uses Sirket::setIsArchive()
     * @uses Sirket::setKodu()
     * @uses Sirket::setUnvani()
     * @uses Sirket::setKisaAdi()
     * @uses Sirket::setVergiDairesi()
     * @uses Sirket::setVergiNo()
     * @param bool $isArchive
     * @param string $kodu
     * @param string $unvani
     * @param string $kisaAdi
     * @param string $vergiDairesi
     * @param string $vergiNo
     */
    public function __construct($isArchive = null, $kodu = null, $unvani = null, $kisaAdi = null, $vergiDairesi = null, $vergiNo = null)
    {
        $this
            ->setIsArchive($isArchive)
            ->setKodu($kodu)
            ->setUnvani($unvani)
            ->setKisaAdi($kisaAdi)
            ->setVergiDairesi($vergiDairesi)
            ->setVergiNo($vergiNo);
    }
    /**
     * Get IsArchive value
     * @return bool
     */
    public function getIsArchive()
    {
        return $this->IsArchive;
    }
    /**
     * Set IsArchive value
     * @param bool $isArchive
     * @return \fk_\StructType\Sirket
     */
    public function setIsArchive($isArchive = null)
    {
        // validation for constraint: boolean
        if (!is_null($isArchive) && !is_bool($isArchive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isArchive, true), gettype($isArchive)), __LINE__);
        }
        $this->IsArchive = $isArchive;
        return $this;
    }
    /**
     * Get Kodu value
     * @return string|null
     */
    public function getKodu()
    {
        return $this->Kodu;
    }
    /**
     * Set Kodu value
     * @param string $kodu
     * @return \fk_\StructType\Sirket
     */
    public function setKodu($kodu = null)
    {
        // validation for constraint: string
        if (!is_null($kodu) && !is_string($kodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kodu, true), gettype($kodu)), __LINE__);
        }
        $this->Kodu = $kodu;
        return $this;
    }
    /**
     * Get Unvani value
     * @return string|null
     */
    public function getUnvani()
    {
        return $this->Unvani;
    }
    /**
     * Set Unvani value
     * @param string $unvani
     * @return \fk_\StructType\Sirket
     */
    public function setUnvani($unvani = null)
    {
        // validation for constraint: string
        if (!is_null($unvani) && !is_string($unvani)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($unvani, true), gettype($unvani)), __LINE__);
        }
        $this->Unvani = $unvani;
        return $this;
    }
    /**
     * Get KisaAdi value
     * @return string|null
     */
    public function getKisaAdi()
    {
        return $this->KisaAdi;
    }
    /**
     * Set KisaAdi value
     * @param string $kisaAdi
     * @return \fk_\StructType\Sirket
     */
    public function setKisaAdi($kisaAdi = null)
    {
        // validation for constraint: string
        if (!is_null($kisaAdi) && !is_string($kisaAdi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kisaAdi, true), gettype($kisaAdi)), __LINE__);
        }
        $this->KisaAdi = $kisaAdi;
        return $this;
    }
    /**
     * Get VergiDairesi value
     * @return string|null
     */
    public function getVergiDairesi()
    {
        return $this->VergiDairesi;
    }
    /**
     * Set VergiDairesi value
     * @param string $vergiDairesi
     * @return \fk_\StructType\Sirket
     */
    public function setVergiDairesi($vergiDairesi = null)
    {
        // validation for constraint: string
        if (!is_null($vergiDairesi) && !is_string($vergiDairesi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vergiDairesi, true), gettype($vergiDairesi)), __LINE__);
        }
        $this->VergiDairesi = $vergiDairesi;
        return $this;
    }
    /**
     * Get VergiNo value
     * @return string|null
     */
    public function getVergiNo()
    {
        return $this->VergiNo;
    }
    /**
     * Set VergiNo value
     * @param string $vergiNo
     * @return \fk_\StructType\Sirket
     */
    public function setVergiNo($vergiNo = null)
    {
        // validation for constraint: string
        if (!is_null($vergiNo) && !is_string($vergiNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vergiNo, true), gettype($vergiNo)), __LINE__);
        }
        $this->VergiNo = $vergiNo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\StructType\Sirket
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
